
import java.util.Arrays;
/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        for (String n : array){
            if(value == n){
                return true;
            }
        }
        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {

        for(int i = 0; i < array.length/2; i++){
            String cheese = array[i]; 
            array[i]= array[array.length - i - 1];
            array[array.length - i - 1] = cheese;
        }
        return array;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {

        for(int i = 0; i < array.length; i++){
            if (array[i] == array[array.length - i - 1]){
                return true;
            }
        }
        return false;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        boolean my = true;
        for(char alphabet = 'a'; alphabet <= 'z'; alphabet++){
            boolean iKnow = false;

            for(int i = 0; i < array.length; i++){
                if(array[i].toLowerCase().contains(Character.toString(alphabet))){

                    iKnow = true;
                    break;

                }

            }
            if(!iKnow){
                my = false; 
                break;
            }
        }
        return my;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int count = 0;
        for(String word: array){
            if(value.equals(word)){
                count++;
            }
        }
        return count;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        int count = getNumberOfOccurrences(array,valueToRemove);
        String[] cheese = new String[array.length - count];
        int j = 0;
        for(int i = 0; i < array.length; i++){
            if(array[i] != valueToRemove){
                cheese[j] = array[i];
                j++;
            }
        }

        return cheese;
    }

    /*
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        int count = 0;
        int duplicate = 0;

        for(int i = 0; i < array.length - 1; i++){
            if (array[i].equals(array[i+1])){
                count++;
            }
        }

        String []arr = new String [array.length - count];
        String strCheese = null;
        for(int i= 0;i < array.length; i++){
            if(!array[i].equals(strCheese)){
                arr[duplicate] = array[i];
                strCheese = array[i];
                duplicate++;
            }

        }
        return arr;

    }
    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        int count = getCount(array);
        String [] result = new String[array.length - count];
        String last = array[0];
        result[0] = array[0];
        int index = 0;
        
        for (int i = 1; i < array.length; i++){
        if (array[i].equals(last)){
            result[index] += array[i];
        }else{
            index++;
            result[index] = array[i];
            last = array[i];
        }
        }
        return result;
    }

    public static int getCount(String [] array){
        int count = 0;
        for(int i = 0; i < array.length - 1; i++){
            if(array[i].equals(array[i+1])){
                count++;
            }
        }
        return count;
    }

}
